/*======================================================*/
/*======================================================*/
/*	CINETUBE Plugin for pelisalacarta para WebTV	*/
/*======================================================*/
/*======================================================*/

if(DEBUG) log("Cargando plugin Cinetube");

/************************/
/*	Define Plugin	*/
/************************/

var cinetube={
	title: "CineTube",
	media: ["Pel&iacute;culas", cinetube_configure_peliculas, "Series", cinetube_configure_series,"Documentales", cinetube_configure_documentales, "Pel&iacute;culas Anime", cinetube_configure_peliculas_anime, "Series Anime", cinetube_configure_series_anime],
	init:  [cinetube_init_main,   cinetube_init_search,   cinetube_init_series,   cinetube_init_seasons,   cinetube_init_chapters,  cinetube_init_versions],
	load:  [cinetube_cargar_pagina],
	render:[cinetube_render_main, cinetube_render_search, cinetube_render_series, cinetube_render_seasons, cinetube_render_chapters, cinetube_render_versions],
	action:[cinetube_action_main, cinetube_action_search, cinetube_action_series, cinetube_action_seasons, cinetube_action_chapters, cinetube_action_versions],
	focus: [cinetube_render_focus]
};

/********************************/
/*	START of Customization	*/
/********************************/

//Configura busquedas y mensajes para buscar series

function cinetube_configure_series() {
	base_url = "http://www.cinetube.es/";
	estructura = "series"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 21; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.cinetube.es/series/"; // series
	search_categories =/<li><a href=\"(series[^\"]*)\"><span>([^<]*)<\/span><\/a><\/li>/g; // series
	search_link_pages = /<li class=\"pagina\"><a href=\"(\/series[^\"]*)\">([^<]*)<\/a><\/li>/g; // series
	search_series = /<li>[^<]*<a href=\"\/(series\/[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"peli\" \/>[^_]*_lg\">[^_]*_ficha\">([^<]*)<\/p>/g; // series 
	search_seasons = /<li><h2><a href=\"\/(series\/[^\"]*)\">([^<]*)<\/a><\/h2><span><[^>]*>([^\|]*)\|/g; // series
	search_brief = /<h3 class=\"tit_cent\">Ficha de la serie<\/h3>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^<]*<p>([^<]*)<\/p>/g; //series
	search_chapters = /<div class=\"title\"> <a class=\"bold\" href=\"\/(series\/[^\"]*)\">([^<]*)<\/a><\/div>/g; //series
	search_versions = /<div class=\"tit_opts\"><a href=\"\/(series\/descargar[^\"]*)\" target=\"_BLANK\">[^<]*<p>([^<]*)<span class=\"bold\"><\/span><\/p>[^<]*<p><span>([^<]*)<\/span><\/p>[^<]*<p class=\"v_ico\"><img src=\"http:\/\/caratulas.cinetube.es\/img\/cont\/megaupload.png\" alt=\"Megaupload\"/g; //series
	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // series
	search_megaupload_url = /(http:\/\/www.megaupload.com\/[^\"]*)\"/g; // series
	url_novelties = "http://www.cinetube.es/series/"; // series
	search_novelties = /<li>[^<]*<a href="\/(series[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\"[^_]*_lg\">[^_]*_[^_]*_ficha\"[^>]*>[^<]*<\/a><\/p>[^<]*<p class=\"tem_fich\">([^<]*)<\/p>/g; //series
	url_buscar = "http://www.cinetube.es/buscar/series/?palabra="; //Series
	text_to_search = ""; //Series;
	search_link_pages_busqueda = /<li class=\"pagina\"><a href=\"(\/buscar\/series\/\?palabra=[^\"]*)\">([^<]*)<\/a><\/li>/g; // series
                                   
	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_series = "<div class='message'></div>No hay series disponibles para esta categor&iacute;a.";
	no_matches_available_seasons = "<div class='message'></div>No hay temporadas disponibles para esta categor&iacute;a.";
	no_matches_available_chapters = "<div class='message'></div>No hay cap&iacute;tulos disponibles para esta serie.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este cap&iacute;tulo.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de series, un momento por favor";
	message_loading_chapters_list = "<div class='message'></div>Cargando lista de cap&iacute;tulos, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de series para ";
	log_loading_seasons = "Cargando la pantalla de temporadas para ";
	log_loading_chapters = "Cargando la pantalla de cap&iacute;tulos para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

//Configura busquedas y mensajes para buscar pelculas

function cinetube_configure_peliculas() {
	base_url = "http://www.cinetube.es/";
	estructura = "peliculas"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 60; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.cinetube.es/peliculas/"; // peliculas
	search_categories =/<li><a href=\"(peliculas[^\"]*)\"><span>([^<]*)<\/span><\/a><\/li>/g; // peliculas
	search_link_pages = /<li class=\"pagina\"><a href=\"(\/peliculas[^\"]*)\">([^<]*)<\/a><\/li>/g; // peliculas
	search_series =  /<!--PELICULA-->[^<]*<[^<]*<div class=\"pelicula_img\"><a href=\"\/(peliculas[^\"]*)\">[^<]*<img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"([^\"]*)\" \/><\/a>/g; // peliculas
	search_versions = /<a href=\"\/(peliculas\/[^\/]*\/descargar.*-megaupload-[^\"]*)\"[^<]*<p>([^<]*)<\/p>[^<]*<p><span>([^<]*)<\/span><\/p>/g; // peliculas
	search_brief = /<\/div>--><div style=\"clear:both\"><\/div>[^<]*<p>([^<]*)<\/p>/g; // peliculas
	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // peliculas
	search_megaupload_url = /(http:\/\/www.megaupload.com\/[^\"]*)\"/g; // series
	url_novelties = "http://www.cinetube.es/peliculas/"; // peliculas
	search_novelties = /<!--PELICULA-->[^<]*<[^<]*<div class=\"pelicula_img\"><a href='\/(peliculas[^\"]*)' >[^<]*<img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"([^\"]*)\" \/><\/a>/g; // peliculas
	url_buscar = "http://www.cinetube.es/buscar/peliculas/?palabra="; //Peliculas
	text_to_search = ""; //Peliculas;
	search_link_pages_busqueda = /<li class=\"pagina\"><a href=\"(\/buscar\/peliculas\/\?palabra=[^\"]*)\">([^<]*)<\/a><\/li>/g; // series

	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_chapters = "<div class='message'></div>No hay pel&iacute;culas disponibles para esta categor&iacute;a.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para esta pel&iacute;cula.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de pel&iacute;culas, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de pel&iacute;culas para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

//Configura busquedas y mensajes para buscar documentales

function cinetube_configure_documentales() {
	base_url = "http://www.cinetube.es/";
	estructura = "documentales"; // Se aceptan "peliculas", "series" o "documentales"
	links_per_page = 36; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.cinetube.es/documentales/"; // documentales
	search_categories =/<li><a href=\"(documentales[^\"]*)\"><span>([^<]*)<\/span><\/a><\/li>/g; // documentales
	search_link_pages = /<li class=\"pagina\"><a href=\"(\/documentales[^\"]*)\">([^<]*)<\/a><\/li>/g; // documentales
	search_series = /<!--PELICULA-->[^<]*<[^<]*<a href=\"\/(documentales[^\"]*)\">[^<]*<div class=\"pelicula_img\">[^<]*<img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"([^\"]*)\" \/>/g; // documentales
	search_chapters = /<div class=\"title\"> <a class=\"bold\" href=\"\/(documentales\/[^\"]*)\">([^<]*)<\/a><\/div>/g; //documentales
	search_versions_series = /<div class=\"tit_opts\"><a href=\"\/(documentales\/descargar[^\"]*)\" target=\"_BLANK\">[^<]*<p>([^<]*)<span class=\"bold\"><\/span><\/p>[^<]*<p><span>([^<]*)<\/span><\/p>[^<]*<p class=\"v_ico\"><img src=\"http:\/\/caratulas.cinetube.es\/img\/cont\/megaupload.png\" alt=\"Megaupload\"/g; //documentales
	search_versions = /<a href=\"\/(documentales\/[^\/]*\/descargar.*-megaupload-[^\"]*)\"[^<]*<p>([^<]*)<\/p>/g; //documentales
	search_brief = /<div class=\"peli_right\">[^<]*<[^<]*<[^<]*<[^<]*<p>([^<]*)<\/p>[^<]*<\/div>/g; // documentales
	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // documentales
	search_megaupload_url = /(http:\/\/www.megaupload.com\/[^\"]*)\"/g; // series
	url_novelties = "http://www.cinetube.es/documentales/"; // documentales
	search_novelties = search_series;
	url_buscar = "http://www.cinetube.es/buscar/documentales/?palabra="; //Documentales
	text_to_search = ""; //Documentales;
	search_link_pages_busqueda = /<li class=\"pagina\"><a href=\"(\/buscar\/documentales\/\?palabra=[^\"]*)\">([^<]*)<\/a><\/li>/g; // series

	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_series = "<div class='message'></div>No hay documentales disponibles para esta categor&iacute;a.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este documental.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de documentales, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages
	
	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de documentales para ";
	log_loading_chapters = "Cargando cap&iacute;tulos para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

//Configura busquedas y mensajes para buscar peliculas Anime

function cinetube_configure_peliculas_anime() {
	base_url = "http://www.cinetube.es/";
	estructura = "peliculas"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 36; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.cinetube.es/peliculas-anime/"; // peliculas-anime
	search_categories =/<li><a href=\"(peliculas-anime[^\"]*)\"><span>([^<]*)<\/span><\/a><\/li>/g; // peliculas-anime
	search_link_pages = /<li class=\"pagina\"><a href=\"(\/peliculas-anime[^\"]*)\">([^<]*)<\/a><\/li>/g; // peliculas-anime
	search_series = /<!--PELICULA-->[^<]*<[^<]*<a href=\"\/(peliculas-anime[^\"]*)\">[^<]*<div class=\"pelicula_img\">[^<]*<img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"([^\"]*)\" \/>/g; // peliculas-anime
	search_versions = /<a href=\"(\/peliculas-anime\/[^\/]*\/descargar.*-megaupload-[^\"]*)\"[^<]*<p>([^<]*)<\/p>/g; //peliculas-anime
	search_brief = /<div class=\"peli_right\">[^<]*<[^<]*<[^<]*<[^<]*<p>([^<]*)<\/p>[^<]*<\/div>/g; // peliculas-anime
	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // peliculas-anime
	search_megaupload_url = /(http:\/\/www.megaupload.com\/[^\"]*)\"/g; // series
	url_novelties = "http://www.cinetube.es/peliculas-anime/"; // peliculas-anime
	search_novelties = search_series;
	url_buscar = "http://www.cinetube.es/buscar/peliculas-anime/?palabra="; //peliculas-anime
	text_to_search = ""; //peliculas-anime;
	search_link_pages_busqueda = /<li class=\"pagina\"><a href=\"(\/buscar\/peliculas-anime\/\?palabra=[^\"]*)\">([^<]*)<\/a><\/li>/g; // series

	// HTML Mensajes
	
	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_chapters = "<div class='message'></div>No hay pel&iacute;culas disponibles para esta categor&iacute;a.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para esta pel&iacute;cula.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de pel&iacute;culas, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de pel&iacute;culas para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "Pagina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

//Configura busquedas y mensajes para buscar series Anime

function cinetube_configure_series_anime() {
	base_url = "http://www.cinetube.es/";
	estructura = "series"; // Se aceptan "Peliculas", "series" o "documentales"
	links_per_page = 21; // Numero de links que hay en cada pgina de Cinetube

	// Bsquedas

	url_categories = "http://www.cinetube.es/series-anime/"; // series-anime
	search_categories =/<li><a href=\"(series-anime[^\"]*)\"><span>([^<]*)<\/span><\/a><\/li>/g; // series-anime
	search_link_pages = /<li class=\"pagina\"><a href=\"(\/series-anime[^\"]*)\">([^<]*)<\/a><\/li>/g; // series-anime
	search_series = /<li>[^<]*<a href=\"\/(series-anime\/[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\" alt=\"peli\" \/>[^_]*_lg\">[^_]*_ficha\">([^<]*)<\/p>/g; // series-anime 
	search_seasons = /<li><h2><a href=\"\/(series-anime\/[^\"]*)\">([^<]*)<\/a><\/h2><span><[^>]*>([^\|]*)\|/g; // series-anime
	search_brief = /<h3 class=\"tit_cent\">Ficha de la serie<\/h3>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^>]*>[^<]*<p>([^<]*)<\/p>/g; //series-anime
	search_chapters = /<div class=\"title\"> <a class=\"bold\" href=\"\/(series-anime\/[^\"]*)\">([^<]*)<\/a><\/div>/g; //series
	search_versions = /<div class=\"tit_opts\"><a href=\"\/(series-anime\/descargar[^\"]*)\" target=\"_BLANK\">[^<]*<p>([^<]*)<span class=\"bold\"><\/span><\/p>[^<]*<p><span>([^<]*)<\/span><\/p>[^<]*<p class=\"v_ico\"><img src=\"http:\/\/caratulas.cinetube.es\/img\/cont\/megaupload.png\" alt=\"Megaupload\"/g; //series-anime
	//search_megaupload_url = /xrxa\(\"([^=]*)=d\?\/moc.daolpuagem.www\/\/:ptth[^\"]*\"\)/g; // series-anime
	search_megaupload_url = /(http:\/\/www.megaupload.com\/[^\"]*)\"/g; // series
	url_novelties = "http://www.cinetube.es/series-anime/"; // series-anime
	search_novelties = /<li>[^<]*<a href="\/(series-anime[^\"]*)\"><img src=\"(http:\/\/caratulas.cinetube.es\/[^\"]*)\"[^_]*_lg\">[^_]*_[^_]*_ficha\"[^>]*>[^<]*<\/a><\/p>[^<]*<p class=\"tem_fich\">([^<]*)<\/p>/g; //series-anime
	url_buscar = "http://www.cinetube.es/buscar/series-anime/?palabra="; //series-anime
	text_to_search = ""; //series-anime;
	search_link_pages_busqueda = /<li class=\"pagina\"><a href=\"(\/buscar\/series-anime\/\?palabra=[^\"]*)\">([^<]*)<\/a><\/li>/g; // series

                                   
	// HTML Mensajes

	no_matches_available_main = "<div class='message'></div>No hay categor&iacute;as disponibles.<br /><br />Por favor, compruebe su conexi&oacute;n o actualice la aplicaci&oacute;n.";
	no_matches_available_series = "<div class='message'></div>No hay series disponibles para esta categor&iacute;a.";
	no_matches_available_seasons = "<div class='message'></div>No hay temporadas disponibles para esta categor&iacute;a.";
	no_matches_available_chapters = "<div class='message'></div>No hay cap&iacute;tulos disponibles para esta serie.";
	no_matches_available_versions = "<div class='message'></div>No hay streams disponibles para este cap&iacute;tulo.";
	message_download_start_ok = "<div class='message'></div>Espere un momento, se est&aacute; pre-buferizando...<br /><div style='font-size:0.6em;'>Pulse RETURN para cancelar la acci&oacute;n.</div>";
	message_megaupload_load_pre = "<div class='message'></div>Obteniendo informaci&oacute;n del stream...<br /><div style='font-size:0.6em;'>";
	message_megaupload_load_post = "</div>";
	message_megaupload_found_stream_ok_pre = "<div class='message'></div>Obteniendo m&aacute;s informaci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_ok_post = "</div>";
	message_megaupload_found_stream_error_pre = "<div class='message'></div>El medio no es compatible, se requieren AVI, MKV o MP4.<br /><div style='font-size:0.6em;'>";
	message_megaupload_found_stream_error_post = "</div><br /><br />Pulse RETURN para volver.";
	message_megaupload_done_title = "Reproducci&oacute;n";
	message_megaupload_done_pre = "<div class='message'></div>Iniciando reproducci&oacute;n de medio...<br /><div style='font-size:0.6em;'>" 
	message_megaupload_done_post = "</div>";
	message_megaupload_wait_pre = "<div class='message'></div>Espere "; 
	message_megaupload_wait_middle = " segundos antes de iniciar la reproducci&oacute;n del medio...<br /><div style='font-size:0.6em;'>";
	message_megaupload_wait_post = "</div>";
	message_megaupload_nostreams = "<div class='message'></div>No se han encontrado streams, es posible que no est&eacute;n disponibles o bien que deba actualizar la aplicaci&oacute;n.<br/><br/>Pulse return para volver a la pantalla anterior.";
	message_getting_information_versions = "<div class='message'></div>Obteniendo informaci&oacute;n y stream...";
	message_getting_information_versions_title = message_megaupload_done_title;
	message_loading_series_list = "<div class='message'></div>Cargando lista de series, un momento por favor";
	message_loading_chapters_list = "<div class='message'></div>Cargando lista de cap&iacute;tulos, un momento por favor";
	message_loading = "<div class='message'></div>Cargando, un momento por favor ...";

	// Log messages

	log_not_supported_fname = "alguna funci&oacute;n"
	log_not_supported_pre = "<span style='color:red'>No se soporta ";
	log_not_suppported_post = "</span>: por favor, actualice la versi&oacute;n de firmware.";
	log_play_error = "Ha fallado la reproducci&oacute;n del medio.";
	log_loading_series = "Cargando la pantalla de series para ";
	log_loading_seasons = "Cargando la pantalla de temporadas para ";
	log_loading_chapters = "Cargando la pantalla de cap&iacute;tulos para ";
	log_loading_versions = "Cargando la pantalla de versiones para ";
	log_loading_descriptor = "Cargando el descriptor ";
	log_error_loading_descriptor = "Error analizando descriptor";
	log_unhandled_key = "unhanled key: ";
	log_page_not_found = "P&aacute;gina no encontrada o error de conexion a la red";
	log_error_getting_pages_pre = "No se han podido descargar todas las p&aacute;ginas. Procesando ";
	log_error_getting_pages_post = " p&aacute;ginas";
	log_error_loading_pages_pre = "Error descargando p&aacute;gina ";
	log_error_loading_pages_post = " solo se mostraran algunos de los medios";
	log_error_analizing_data = "Error analizando datos de ";
	log_init = "Recuerde: debe actualizar la aplicaci&oacute;n frecuentemente para mantener la compatibilidad.";
}

/************************/
/*	Main		*/
/************************/

var cinetube_main_list;

//Initialize the behaviour of the main page

function cinetube_multiplexed_callback (reason, args) {
	//if (DEBUG) log("Razon: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			log(log_page_not_found);
			break;
	}
}

function cinetube_search_error_callback() {
	log(log_error_analizing_data + current_url);
	v_loading=false;
}

function cinetube_init_main(){

	//if(DEBUG) log ("Inicializando main");
	//Configure list template
	template_key_handler = list_key_handler;
	focus_div = list_focus_div;
	blur_div = list_blur_div;
	list_no_matches_available = no_matches_available_main;
	//Visitamos primero pa pagina de acceso por si hay alguna cookie o alguna medida de seguridad
	//HED.helpers.url({url: current_url = "http://www.cinetube.es/", matchlink: "http://*peliculas/*", cbok: function(data) {}});
	//La expresin regular de la siguiente linea es lo que selecciona las categorias. 
	//Se puede cambiar para que salgan clasificadas de otra forma, pero el orden alfabetico es 
	//la nica forma que he encontrado para que las listas salgan enteras en una pgina.
	//Si no sale todo en una pgina habra que complicar el resto de busquedas para que tnegan en cuenta las busquedas paginadas
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	HED.helpers.url({url: current_url = url_categories, match: match_current = search_categories, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if(DEBUG) log("Loaded main page");
		//if (this_loading_ref !== v_loading_ref) return;
		cinetube_main_list =new Array();
		cinetube_main_list.push({title: "Novedades", url: ""});
		cinetube_main_list.push({title: "Buscar", url: ""});
		var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
		for (var i=0; i<maximum; i++) cinetube_main_list.push(HED.helpers.url({url: current_url, match: match_current, get: i}));
		v_visible=14;
		template_key_handler = list_key_handler;
		focus_div = list_focus_div;
		blur_div = list_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: cinetube_search_error_callback, cbmx: cinetube_multiplexed_callback});
}

//Renderiza el men de categoras

function cinetube_render_main() {

	list_render(cinetube_main_list, "", "");
	//render_focus();



}

//What to do when OK is pressed under the main menu

function cinetube_action_main() {
	//Novedades
	if ((v_screen_sel==0) && (v_screen_ofs==0)) {
		cathegory_url_backup = url_novelties;
		cathegory_title_backup = "Novedades";
		if (DEBUG) log(log_loading_series + cathegory_url_backup);
		serie_return_backup="main";
		v_screen = "series";
	}
	//buscar
	else if ((v_screen_sel==1) && (v_screen_ofs==0)) {
		cathegory_url_backup = url_buscar;
		cathegory_title_backup = "Buscar";
		//if (DEBUG) log(log_loading_series + cathegory_url_backup);
		serie_return_backup="main";
		v_screen = "search";
	}
	else if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel-2})) !== false) {
		if ((cathegory_title_backup != v_screen_sel_data.title) || (!pages_left)) page_number = 0;
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) cathegory_url_backup = base_url + v_screen_sel_data.url; else cathegory_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) cathegory_title_backup = v_screen_sel_data.title; else cathegory_title_backup = "(descarga progresiva en curso)";
		if (DEBUG) log(log_loading_series + cathegory_url_backup);
		serie_return_backup="main";
		v_screen = "series";
	}
}

/************************/
/*	Search		*/
/************************/

//Initialize the behaviour of the search page

function cinetube_init_search(){
	//if(DEBUG) log ("Inicializando search");
	render_screen();
	render_focus();
	//if (this_loading_ref !== v_loading_ref) return;
	v_loading = false;
}

//Renderiza el men de bsqueda

function cinetube_render_search() {
	var divheight = 36;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 14;
	maximum=5;

	//if (DEBUG) log("Renderizando la pantalla de bsqueda");

	//Margen con el ttulo
	dumphtml += "<div class='cinetube_noarrow_search'></div>";

	//div para el input_text
	dumphtml += "<div id='write_here'/>";

	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;

	//Define el cuadro de texto
	var my_input = HED.widgets.input_text({
        	parent: $('#write_here'),
        	type: 'text',
        	initText: text_to_search,
        	defaultEnabled: true,
        	oStyle: {'width': '600px', 'height': '30px', 'margin': '0 auto'},
	        fCallback: {
		        select: function(oEvent, thevalue) {
				if (oEvent.keyCode==HED.KC_RETURN) {
					v_screen = "main"
					init_screen();
				}
				else {
					page_number = 0;
					cathegory_url_backup = url_buscar + thevalue;
					cathegory_title_backup = "Buscar: "+ thevalue;
					if (DEBUG) log(log_loading_series + cathegory_url_backup);
					serie_return_backup="main";
					v_screen = "series";
					cathegory_ofs_backup = v_screen_ofs;
					cathegory_sel_backup = v_screen_sel;
					init_screen();
		        	}
			}        
	        },        
		kc : {
			undo: [],
			enable : [],
			disable: [],
			select: [HED.KC_ENTER, HED.KC_RETURN]
		}
	});
	$('#write_here a:first').focus();
}


//What to do when OK is pressed under the search menu

function cinetube_action_search() {};

/************************/
/*	Series		*/
/************************/

//Initialize the behaviour of the series page
//With the posibility of accepting pagination of the main list and using thumbhnails

//Callabcks para cargar una sola pgina de enlaces

function cinetube_muxcb_contar_paginas (reason, args) {
	//if (DEBUG) log("Razon: " + reason);
	switch (reason) {
		case "data-cannot-fetch":
			if(num_pages==undefined) num_pages=1;
			//if (DEBUG) log("Imposible descargar mas paginas");
			if (DEBUG) log(log_error_getting_pages_pre + num_pages + log_error_getting_pages_post);
			//if (DEBUG) log("Procesando " + num_pages + " paginas para " + cathegory_url_backup);
			all_data = "";
			page_number = 0;
			url_callback_series(); /// empezar la secuencia, con page 0 no hace nada y se rellama
			break;
	}
}

function cinetube_error_cargando_pagina() {
	log(log_error_analizing_data + current_url);
	v_loading=false;
	--page_number;
}

function cinetube_cargar_pagina(){
	if(page_number==0) {
		all_data="";
		pages_left=true;
	};
	++page_number;
	if (pages_left) {
		if (v_screen=="series") {
			v_loading=true;
			//domobj = document.getElementById("fields"); 
			//domobj.innerHTML += ".";
			//if (DEBUG) log(cathegory_title_backup);
			if (cathegory_title_backup.search("Buscar: ")!=-1) 
				var url_a_buscar = cathegory_url_backup + "&pag=" + page_number;
			else 
				var url_a_buscar = cathegory_url_backup + page_number + ".html";
			//if (DEBUG) log("Procesando pagina " + cathegory_url_backup + page_number + ".html");
			HED.helpers.url({url: current_url = url_a_buscar, cbok: function(data) {  
				//if (DEBUG) log("Anadiendo informacion de la pagina " + page_number);
				all_data += data;
				//if (DEBUG) log("Comprobando si es la ultima pagina");
				if(v_screen=="series") {
				


					if (cathegory_title_backup.search("Buscar: ")!=-1) 
						var busqueda_a_buscar = search_link_pages_busqueda;
					else 
						var busqueda_a_buscar = search_link_pages;

				
				HED.helpers.url({url: current_url, match: match_current = busqueda_a_buscar, cbok: function(data) {
					var num_enlaces = HED.helpers.url({url: current_url, match: match_current, get: "len"})-1;
					//if (DEBUG) log("Numero de anlaces:" + num_enlaces);
					var enlace = HED.helpers.url({url: current_url, match: match_current, get: num_enlaces});
					//if (DEBUG) log("Procesando pagina:" + page_number);
					//if (DEBUG) log("Ultimo enlace:" + enlace.title);
					if ((enlace.title > page_number) && (num_enlaces>-1)) pages_left = true;
					else {
						pages_left = false;
						num_pages = page_number;
						//if (DEBUG) log("Se han encontrado " + num_pages + " paginas de enlaces");
					}
				}, cber: cinetube_search_error_callback, cbmx: cinetube_muxcb_contar_paginas});};
				//Busca matches dentro de los datos almacenados
				if(v_screen=="series"){
					HED.helpers.url({url: current_url = "megaupload-main-cache-container-" + cathegory_title_backup, matchnames: ["url", "image", "title"], data: all_data, match: match_current = search_series, get: "clean"});
					HED.helpers.url({url: current_url = "megaupload-main-cache-container-" + cathegory_title_backup, matchnames: ["url", "image", "title"], data: all_data, match: match_current = search_series, cbok: function(data) {
						if(v_screen=="series") {
							render_screen();
							render_focus();
							v_loading = false;
							if ((typeof callback) == "function") callback();
						}
					}, cber: cinetube_error_cargando_pagina, cbmx: cinetube_multiplexed_callback});
				}
			}, cber: cinetube_error_cargando_pagina });
		}
	}
}

function cinetube_init_series(){
	//if (DEBUG) log(cathegory_url_backup);
	//HED.helpers.url({url: current_url = "about:blank", cbok: function (data){}});
	if ((cathegory_title_backup == "Novedades")){   // || (cathegory_title_backup == "Buscar")) {
		//if (DEBUG) log("Cargando Novedades");
		if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading_series_list + anim_puntos[page_number%3];
		HED.helpers.url({url: current_url = cathegory_url_backup, matchnames: ["url", "image", "title"], match: match_current = search_novelties, cbok: function(data) {
			//HED.helpers.url({url: current_url, action: "clean"});
			//if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading_series_list + anim_puntos[page_number%3];
			//if (this_loading_ref !== v_loading_ref) {
				//if (DEBUG) log("ERROR buscando matches");
				//return;
			//}
			//if (DEBUG) log("primer match: url:" + data[0].url + " title " +data[0].title + " image " + data[0].image);
			template_key_handler = others_key_handler;
			focus_div = others_focus_div;
			blur_div = others_blur_div;
			render_screen();
			render_focus();
			v_loading = false;
			if ((typeof callback) == "function") callback();
		}, cber: cinetube_search_error_callback, cbmx: cinetube_multiplexed_callback});
	}
	//Recorre las pginas de pelculas para capturar los enlaces
	else {
		//all_data = "";
		//page_number = 0;
		//url_callback_series(); 		/// empezar la secuencia, con page 0 no hace nada y se rellama
		//Configure template
		template_key_handler = others_key_handler;
		focus_div = others_focus_div;
		blur_div = others_blur_div;
		cinetube_cargar_pagina();
	}

}

//Renderiza el men de series (Con cartulas)

function cinetube_render_series() {
	var divheight=150;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 14;

	//Calcula el numero de elementos

	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
	//if (DEBUG) log("Encontrados " + maximum + " matches");

	//Si no se han cargado aun todas las pginas de enlaces no es posible usar el men de forma cclica (pasar del primero al ltimo)
	if(pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= maximum) v_screen_sel = maximum-1;
	}
	else {
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
	}

	//Comprueba los lmites
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - (v_screen_sel%v_visible) - (v_visible/2);
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
			
	//Si no hay elementos disponibles muestra el error
	if (maximum <= 0) {
		setTimeout(function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = no_matches_available_series;}, 250);
	} else { //Y si los hay, renderiza el men
		var description;
		var cover;
		//Red arrow
		if (v_screen_ofs > 0) dumphtml += "<div style='height:" + (arrow * 1) + "px; position: relative; left: -26px' class='arrow redarrow'>&#9650;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Aade el contenedor para la matriz de cartulas
		dumphtml += "<div class=\"matrixcontainer\">";
		//Bucle principal para mostrar todas las opciones disponibles
		var bucle_start = 0;
		for (var i = bucle_start; (i < v_visible) && ((v_screen_ofs + i)<maximum); ++i) {
			//Lee los datos del i-esimo match 
			v_screen_tmp_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i, matchnames: ["url", "image", "title"]});
			cover = (v_screen_tmp_data === false) ? "" : (v_screen_tmp_data.image ? v_screen_tmp_data.image : "");
			description = (v_screen_tmp_data === false) ? "" : (v_screen_tmp_data.title ? v_screen_tmp_data.title : "");
			//Aade el elemento i-esimo al al men sin superar el ltimo disponible
			if (i+v_screen_ofs<maximum) dumphtml += "<div class='matrixelementdiv' id='matrixelement" + i + "'><img src='"+cover+"' class=\"coverimage\" /><a href='#' id='element" + i + "' class='element' style='font-size:75%; margin-top: 4px;'> " + description + "</a></div>";
		}
		//Cierra el contenedor de la matriz de cartulas
		dumphtml += "</div>";
		//Blue Arow
		if (v_screen_ofs < maximum - v_visible) dumphtml += "<div style='height:" + (arrow * 1) + "px; position: relative; top: 500px; left: 15px;' class='arrow bluearrow'>&#9660;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
	}
	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}

//What to do when OK is pressed under the series menu

function cinetube_action_series() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel, matchnames: ["url", "image", "title"]})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) serie_url_backup = base_url + v_screen_sel_data.url; else serie_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) serie_title_backup = v_screen_sel_data.title; else serie_title_backup = cathegory_title_backup;
		if(serie_url_backup.search("serie-documental")!=-1) { 
			if (DEBUG) log(log_loading_chapters + serie_url_backup);
			chapter_return_backup="series";
			v_screen = "chapters";
		}
		else {
			if (cathegory_title_backup == "Novedades"){
				if (serie_url_backup.search("capitulo")!=-1) {
					chapter_url_backup = serie_url_backup;
					chapter_title_backup = serie_title_backup;
					if (DEBUG) log(log_loading_versions + serie_url_backup);
					v_screen = "versions";
					version_return_backup="series";
				}
				else {
					season_url_backup = serie_url_backup;
					season_title_backup = serie_title_backup;
					if (estructura=="series"){
						if (DEBUG) log(log_loading_chapters + serie_url_backup);
						v_screen = "chapters";
						chapter_return_backup="series";
					}
					if (estructura=="peliculas"){
						if (DEBUG) log(log_loading_versions + serie_url_backup);
						if(cathegory_title_backup.search("Buscar: ")!=-1) page_number=0;
						v_screen = "versions";
						version_return_backup="series";
					}
					if (estructura=="documentales"){
						if (DEBUG) log(log_loading_versions + serie_url_backup);
						page_number=0;
						v_screen = "versions";
						version_return_backup="series";
					}
				}
			}
			else {
				if((estructura=="peliculas") || (estructura=="documentales")) if (DEBUG) log(log_loading_versions + serie_url_backup);
				if(estructura=="series") if (DEBUG) log(log_loading_seasons + serie_url_backup);
				if((estructura=="peliculas") || (estructura=="documentales")) {
					v_screen = "versions";
					version_return_backup="series";
					if(cathegory_title_backup.search("Buscar: ")!=-1) page_number=0;
				}
				if(estructura=="series") {
					v_screen = "seasons";
					season_return_backup="series";
						if(cathegory_title_backup.search("Buscar: ")!=-1) page_number=0;
				}
			}
		}
	}
	imagen=v_screen_sel_data.image;
	titulo=v_screen_sel_data.title;
}

/************************/
/*	Seasons		*/
/************************/

//Initialize the behaviour of the seasons page

function cinetube_init_seasons(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	//La expresin regular de la siguiente linea es la que busca enlaces a las pginas de temporadas
	HED.helpers.url({url: current_url = serie_url_backup, matchnames: ["url", "title", "description"], match: match_current = search_seasons, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if (this_loading_ref !== v_loading_ref) return;
		template_key_handler = others_key_handler;
		focus_div = others_focus_div;
		blur_div = others_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: cinetube_search_error_callback, cbmx: cinetube_multiplexed_callback});
}

//Renderiza el men de temporadas

function cinetube_render_seasons() {
	var divheight=36;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 14;

	//Reduce el tamao del men para dejar sitio a la sinopsis en el caso de las series
	if(estructura == "series") v_visible = 7;

	//Calcula el numero de elementos
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
	//if (DEBUG) log("Encontrados " + maximum + " matches");

	//Comprueba los lmites
	if (v_screen_sel < 0) v_screen_sel = maximum - 1;
	if (v_screen_sel >= maximum) v_screen_sel = 0;
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
			
	//Si no hay elementos disponibles muestra el error
	if (maximum <= 0) {
		setTimeout(function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = no_matches_available_seasons;}, 250);
	} else { //Y si los hay, renderiza el men
		var description;
		//Red Arrow
		if (v_screen_ofs > 0) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='arrow redarrow'>&#9650;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Bucle principal para mostrar todas las opciones disponibles
		var bucle_start = 0;
		for (var i = bucle_start; (i < v_visible) && ((v_screen_ofs + i)<maximum); ++i) {
			//Lee los datos del i-esimo match 
			v_screen_tmp_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i, matchnames: ["url", "title", "description"]});
			description = (v_screen_tmp_data === false) ? "" : (v_screen_tmp_data.title ? v_screen_tmp_data.title : "");
			description += ": " + v_screen_tmp_data.description ;
			//Aade el elemento i-esimo al al men sin superar el ltimo disponible
			dumphtml += "<div style='height:" + divheight + "px;' class='elementdiv'><a href='#' id='element" + i + "' class='element'>" + description + "</a></div>";
		}
		//Blue Arrow
		if (v_screen_ofs < maximum - v_visible) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='arrow bluearrow'>&#9660;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Incluye el resumen y la cartula si la estructura es la de las series
		if(estructura=="series") {
			var datos = HED.helpers.url({url: current_url, matchnames: ["brief"], match: search_brief, get: 0});
			dumphtml = "<div class='ficha'><div class='coverimage'><img src='"+imagen+"' width=\"134\" height=\"193\" border=\"0\" /></div><div class='imagetitle'> " + titulo + "</div><br><div class='brief'>" + datos.brief + "</div></div>" + dumphtml;
		}
	}
	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}

//What to do when OK is pressed under the seasons menu

function cinetube_action_seasons() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel, matchnames: ["url", "title", "description"]})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) season_url_backup = base_url + v_screen_sel_data.url; else season_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) season_title_backup = v_screen_sel_data.title; else season_title_backup = serie_title_backup;
		if (DEBUG) log(log_loading_chapters + season_url_backup);
		chapter_return_backup="seasons";
		v_screen = "chapters";
	}
}

/************************/
/*	Chapters	*/
/************************/

//Initialize the behaviour of the chapters page

function cinetube_init_chapters(){
	if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
	if (estructura == "series") var url_busqueda = season_url_backup;
	if ((estructura == "peliculas") || (estructura=="documentales")) var url_busqueda = serie_url_backup;
	HED.helpers.url({url: current_url = url_busqueda, match: match_current = search_chapters, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		//if (this_loading_ref !== v_loading_ref) return;
		template_key_handler = others_key_handler;
		focus_div = others_focus_div;
		blur_div = others_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: cinetube_search_error_callback, cbmx: cinetube_multiplexed_callback});
}

//Renderiza el men de captulos

function cinetube_render_chapters() {
	var divheight=36;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 14;

	//Reduce el tamao del men para dejar sitio a la sinopsis en el caso de las series de documentales
	if( (estructura == "documentales") && (serie_url_backup.search("serie-documental")!=-1)) v_visible = 7;

	//Calcula el numero de elementos
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
	//if (DEBUG) log("Encontrados " + maximum + " matches");

	//Comprueba los lmites
	if (v_screen_sel < 0) v_screen_sel = maximum - 1;
	if (v_screen_sel >= maximum) v_screen_sel = 0;
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
			
	//Si no hay elementos disponibles muestra el error
	if (maximum <= 0) {
		setTimeout(function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = no_matches_available_chapters;}, 250);
	} else { //Y si los hay, renderiza el men
		var description;
		//Red Arrow
		if (v_screen_ofs > 0) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='arrow redarrow'>&#9650;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Bucle principal para mostrar todas las opciones disponibles
		var bucle_start = 0;
		for (var i = bucle_start; (i < v_visible) && ((v_screen_ofs + i)<maximum); ++i) {
			//Lee los datos del i-esimo match 
			v_screen_tmp_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i});
			description = (v_screen_tmp_data === false) ? "" : (v_screen_tmp_data.title ? v_screen_tmp_data.title : "");
			//Aade el elemento i-esimo al al men sin superar el ltimo disponible
			dumphtml += "<div style='height:" + divheight + "px;' class='elementdiv'><a href='#' id='element" + i + "' class='element'>" + description + "</a></div>";
		}
		//Blue Arrow
		if (v_screen_ofs < maximum - v_visible) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='arrow bluearrow'>&#9660;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Incluye el resumen y la cartula si la estructura es la de las series de documentales
		if((estructura == "documentales") && (serie_url_backup.search("serie-documental")!=-1)) {
			var datos = HED.helpers.url({url: current_url, matchnames: ["brief"], match: search_brief, get: 0});
			dumphtml = "<div class='ficha'><div class='coverimage'><img src='"+imagen+"' width=\"134\" height=\"193\" border=\"0\" /></div><div class='imagetitle'> " + titulo + "</div><br><div class='brief'>" + datos.brief + "</div></div>" + dumphtml;
		}
	}
	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}

//What to do when OK is pressed under the chapters menu

function cinetube_action_chapters() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) chapter_url_backup = base_url + v_screen_sel_data.url; else chapter_url_backup = "";
		if ((v_screen_sel_data) && (v_screen_sel_data.title)) chapter_title_backup = v_screen_sel_data.title; else chapter_title_backup = season_title_backup;
		if (DEBUG) log(log_loading_versions + chapter_url_backup);
		v_screen = "versions";
		version_return_backup="chapters";
	}
}

/************************/
/*	Versions	*/
/************************/

//Initialize the behaviour of the versions page

function cinetube_init_versions(){
	//HED.helpers.url({url: current_url = "about:blank", cbok: function (data){}});
	//La expresin regular de la siguiente linea es la que busca enlaces a las pginas de descarga
	if (estructura == "series") var busqueda = chapter_url_backup;
	if (estructura == "peliculas") var busqueda = serie_url_backup;
	var busqueda_versiones = search_versions;
	if (estructura == "documentales") {
		var busqueda = serie_url_backup;
		if (serie_url_backup.search("serie-documental")!=-1) {
			var busqueda = chapter_url_backup;
			busqueda_versiones=search_versions_series;
		}	
	}
	HED.helpers.url({url: current_url = busqueda, matchnames: ["url", "title", "description"], match: match_current = busqueda_versiones, cbok: function(data) {
		//HED.helpers.url({url: current_url, action: "clean"});
		if (domobj = document.getElementById("fields")) domobj.innerHTML = message_loading;
		//if (this_loading_ref !== v_loading_ref) return;
		v_screen_ofs = version_ofs_backup; 	/// restore backup
		v_screen_sel = version_sel_backup; 	/// restore backup
		megaupload_return_backup = "versions";
		template_key_handler = others_key_handler;
		focus_div = others_focus_div;
		blur_div = others_blur_div;
		render_screen();
		render_focus();
		v_loading = false;
		if ((typeof callback) == "function") callback();
	}, cber: cinetube_search_error_callback, cbmx: cinetube_multiplexed_callback});
}

//Renderiza el men de versiones

function cinetube_render_versions() {
	var divheight=36;
	var arrow=26;
	var dumphtml = ""; 
	v_visible = 14;

	//Reduce el tamao del men para dejar sitio a la sinopsis en el caso de los documentales o las pelculas
	if( ((estructura == "peliculas")) || ((estructura == "documentales") && (serie_url_backup.search("serie-documental")==-1)) ) v_visible = 7;

	//Calcula el numero de elementos
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});
	//if (DEBUG) log("Encontrados " + maximum + " matches");

	//Comprueba los lmites
	if (v_screen_sel < 0) v_screen_sel = maximum - 1;
	if (v_screen_sel >= maximum) v_screen_sel = 0;
	if (v_screen_ofs === undefined) v_screen_ofs = v_screen_sel;
	if (v_screen_ofs < (v_screen_sel - v_visible + 1)) v_screen_ofs = v_screen_sel - v_visible + 1;
	if (v_screen_ofs < 0) v_screen_ofs =0;
	if (v_screen_ofs > v_screen_sel) v_screen_ofs = v_screen_sel;
	
	//Si no hay elementos disponibles muestra el error
	if (maximum <= 0) {
		setTimeout( function() {if (domobj = document.getElementById("fields")) domobj.innerHTML = no_matches_available_versions;}, 250);
	} else { //Y si los hay, renderiza el men
		var description;
		var cover;
		//Red Arrow
		if (v_screen_ofs > 0) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='arrow redarrow'>&#9650;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Bucle principal para mostrar todas las opciones disponibles
		var bucle_start = 0;
		for (var i = bucle_start; (i < v_visible) && ((v_screen_ofs + i)<maximum); ++i) {
			//Lee los datos del i-esimo match 
			v_screen_tmp_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_ofs + i, matchnames: ["url", "title", "description"]});
			description = (v_screen_tmp_data === false) ? "" : (v_screen_tmp_data.title ? v_screen_tmp_data.title : "");
			description += "<span style='font-size:0.6em;'> " + v_screen_tmp_data.description + "</span>";
			//Aade el elemento i-esimo al al men sin superar el ltimo disponible
			dumphtml += "<div style='height:" + divheight + "px;' class='elementdiv'><a href='#' id='element" + i + "' class='element'>" + description + "</a></div>";
		}
		//Blue Arrow
		if (v_screen_ofs < maximum - v_visible) dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='arrow bluearrow'>&#9660;</div>"; else dumphtml += "<div style='height:" + (arrow * 1) + "px;' class='noarrow'></div>";
		//Incluye el resumen y la cartula si la estructura es la de las peliculas o documentales
		if( ((estructura == "peliculas")) || ((estructura == "documentales") && (serie_url_backup.search("serie-documental")==-1)) ) {
			var datos = HED.helpers.url({url: current_url, matchnames: ["brief"], match: search_brief, get: 0});
			dumphtml = "<div class='ficha'><div class='coverimage'><img src='"+imagen+"' width=\"134\" height=\"193\" border=\"0\" /></div><div class='imagetitle'> " + titulo + "</div><br><div class='brief'>" + datos.brief + "</div></div>" + dumphtml;
		}
	}
	//Muestra el men
	if (domobj = document.getElementById("fields")) domobj.innerHTML = dumphtml;
}

//What to do when OK is pressed under the versions menu

function cinetube_action_versions() {
	if ((v_screen_sel_data = HED.helpers.url({url: current_url, match: match_current, get: v_screen_sel})) !== false) {
		if ((v_screen_sel_data) && (v_screen_sel_data.url)) {
			version_url_backup = v_screen_sel_data.url;
			megaupload_return_backup="versions";
			v_screen = "megaupload";
			if (domobj = document.getElementById("fields")) domobj.innerHTML = message_getting_information_versions; 
			if (domobj = document.getElementById("title")) domobj.innerHTML = message_getting_information_versions_title;
			if (DEBUG) log(log_loading_descriptor + base_url + version_url_backup);
			HED.helpers.url({url: current_url = base_url + version_url_backup, match: match_current = search_megaupload_url, cbok: function(data) {
				v_screen_tmp_data = HED.helpers.url({url: current_url, match: match_current, get: 0});
				//megaupload_url="http://www.megaupload.com/?d=" + v_screen_tmp_data.url.charAt(7) + v_screen_tmp_data.url.charAt(6) + v_screen_tmp_data.url.charAt(5) + v_screen_tmp_data.url.charAt(4) + v_screen_tmp_data.url.charAt(3) + v_screen_tmp_data.url.charAt(2) + v_screen_tmp_data.url.charAt(1) + v_screen_tmp_data.url.charAt(0);
				megaupload_url=v_screen_tmp_data.url;
				//if (DEBUG) log("Reproducir " + megaupload_url);
				play_handler(megaupload_url);
			}, cber: function(data){if (DEBUG) log(log_error_loading_descriptor)}});
		}
	}
}

/************************/
/*	Focus Handling	*/
/************************/

function cinetube_render_focus() {
	var maximum = HED.helpers.url({url: current_url, match: match_current, get: "len"});	


	if(v_screen=="main") maximum = list_maximum;
	//if(DEBUG) log("La lista tiene " + maximum + " elementos");
	//if(DEBUG) log("y esta seleccionado el elemento " + v_screen_sel);
	if((v_screen == "series") && pages_left) {
		if (v_screen_sel < 0) v_screen_sel = 0;
		if (v_screen_sel >= maximum) v_screen_sel = maximum-1;
	}
	else {
		//if (DEBUG) log("Renderizando foco, comprobando limites");
		if (v_screen_sel < 0) v_screen_sel = maximum - 1;
		if (v_screen_sel >= maximum) v_screen_sel = 0;
	}


	//if(DEBUG) log("y ahora esta seleccionado el elemento " + v_screen_sel);

	if (v_screen=="search") { 
		if (DEBUG) log("pagina de busqueda, renderizando foco");
		if (domobj = document.getElementById("write_here")) {
			//if (DEBUG) log("div encontrado");
			domobj.focus();
		}
		else {
			//if (DEBUG) log("no he encontrado el div");
		}
	}
	else {
		//if (DEBUG) log("pagina normal, renderizando foco");
		if ((v_screen_ofs === undefined) || (v_screen_ofs < (v_screen_sel - v_visible + 1)) || (v_screen_ofs > v_screen_sel)) {
			render_screen();
			setTimeout(focus_div, 10, v_screen_sel - v_screen_ofs);
		} else {
			blur_div(v_screen_sel_last - v_screen_ofs_last);
			focus_div(v_screen_sel-v_screen_ofs);
		}
	}

	var titulo = "";

	switch (v_screen) {
		case "main":
			if (maximum > 0) titulo = media_title_backup + " / " + "Categor&iacute;as " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = media_title_backup + " / " + "Categor&iacute;as";
			break;
		case "search":
			titulo = media_title_backup + " / " +"Buscar " + text_to_search;
			break;
		case "series":
			if(pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + " " + (v_screen_sel + 1) + " / ---";
			if(!pages_left) if (maximum > 0) titulo = media_title_backup + " / " +cathegory_title_backup + " " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = cathegory_title_backup;
			break;
		case "seasons":
			if (maximum > 0) titulo = media_title_backup + " / " + serie_title_backup + " / Temporadas disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "chapters":
			if (maximum > 0) titulo = media_title_backup + " / " + serie_title_backup + " / " + season_title_backup + " / Cap&iacute;tulos disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
		case "versions":
			if (maximum > 0) titulo = media_title_backup + " / " + serie_title_backup + " / " + season_title_backup + " / " + chapter_title_backup + " / Versiones disponibles " + (v_screen_sel + 1) + " / " + maximum;
			if (!(maximum > 0)) titulo = "Versiones";
			break;
	}
	if (titulo.length>70) titulo = "..." + titulo.slice(titulo.length-70);
	if (domobj = document.getElementById("title")) domobj.innerHTML=titulo;
}


